" Vim syntax file
" Language:	Vim script
" Maintainer:	Dr. Charles E. Campbell, Jr. <cec@gryphon.gsfc.nasa.gov>
" Last change:	May 18, 1998

" Remove old syntax
syn clear

syn keyword vimTodo contained	TODO

" regular vim commands
syn keyword vimCommand contained	I	di[splay]	mk[exrc]	sbp[revious]	wn[ext]
syn keyword vimCommand contained	N[ext]	dig[raphs]	mks[ession]	sbr[ewind]	wp[revous]
syn keyword vimCommand contained	a[ppend]	display	mkv[imrc]	se[t]	wq
syn keyword vimCommand contained	ab[breviate]	dj[ump]	mod[e]	set	wqa[ll]
syn keyword vimCommand contained	abc[lear]	dl[ist]	n[ext]	sh[ell]	wqall
syn keyword vimCommand contained	al[l]	do[autocmd]	new	si[malt]	wv[iminfo]
syn keyword vimCommand contained	ar[gs]	doautoa[ll]	nm[ap]	sl[eep]	x[it]
syn keyword vimCommand contained	argu[ment]	ds[earch]	nmap	sla[st]	xa[ll]
syn keyword vimCommand contained	as[cii]	dsp[lit]	nmapc[lear]	sn[ext]	xall
syn keyword vimCommand contained	au[tocmd]	e[dit]	nn[oremap]	so[urce]	y[ank]
syn keyword vimCommand contained	aug[roup]	ec[ho]	no[remap]	sp[lit]	am
syn keyword vimCommand contained	autocmd	echoh[l]	norea[bbrev]	spr[evious]	amenu
syn keyword vimCommand contained	bN[ext]	echon	norm[al]	sr[ewind]	an
syn keyword vimCommand contained	b[uffer]	else	normal	st[op]	anoremenu
syn keyword vimCommand contained	ba[ll]	elsei[f]	nu[mber]	sta[g]	aun
syn keyword vimCommand contained	bad[d]	en[dif]	nun[map]	stj[ump]	aunmenu
syn keyword vimCommand contained	bd[elete]	endw[hile]	o[pen]	sts[elect]	cme
syn keyword vimCommand contained	bdelete	ex	om[ap]	sun[hide]	cmenu
syn keyword vimCommand contained	bl[ast]	exe[cute]	omap	sus[pend]	cnoreme
syn keyword vimCommand contained	bm[odified]	exi[t]	omapc[lear]	sv[iew]	cnoremenu
syn keyword vimCommand contained	bn[ext]	f[ile]	on[ly]	syntax	cunme
syn keyword vimCommand contained	bp[revious]	files	ono[remap]	t	cunmenu
syn keyword vimCommand contained	br[ewind]	fix[del]	ou[nmap]	tN[ext]	ime
syn keyword vimCommand contained	brea[k]	g[lobal]	p[rint]	ta[g]	imenu
syn keyword vimCommand contained	bro[wse]	global	pe[rl]	tags	inoreme
syn keyword vimCommand contained	buffers	h[elp]	perld[o]	tc[l]	inoremenu
syn keyword vimCommand contained	bun[load]	hid[e]	po[p]	tcld[o]	iunme
syn keyword vimCommand contained	bunload	highlight	pre[serve]	tclf[ile]	iunmenu
syn keyword vimCommand contained	cN[ext]	i[nsert]	prev[ious]	te[aroff]	me
syn keyword vimCommand contained	c[hange]	ia[bbrev]	pw[d]	the	menu
syn keyword vimCommand contained	ca[bbrev]	iabc[lear]	py[thon]	tj[ump]	nme
syn keyword vimCommand contained	cabc[lear]	if	pyf[ile]	tl[ast]	nmenu
syn keyword vimCommand contained	cc	ij[ump]	q[uit]	tm[enu]	nnoreme
syn keyword vimCommand contained	cd	il[ist]	qa[ll]	tn[ext]	nnoremenu
syn keyword vimCommand contained	ce[nter]	im[ap]	qall	tp[revious]	noreme
syn keyword vimCommand contained	cf[ile]	imap	quit	tr[ewind]	noremenu
syn keyword vimCommand contained	chd[ir]	imapc[lear]	r[ead]	ts[elect]	nunme
syn keyword vimCommand contained	che[ckpath]	ino[remap]	rec[over]	tu[nmenu]	nunmenu
syn keyword vimCommand contained	cl[ist]	inorea[bbrev]	red[o]	u[ndo]	ome
syn keyword vimCommand contained	clast	is[earch]	redi[r]	una[bbreviate]	omenu
syn keyword vimCommand contained	clo[se]	isp[lit]	reg[isters]	unh[ide]	onoreme
syn keyword vimCommand contained	cm[ap]	iu[nmap]	res[ize]	unl[et]	onoremenu
syn keyword vimCommand contained	cmap	iuna[bbrev]	resize	unm[ap]	ounme
syn keyword vimCommand contained	cmapc[lear]	j[oin]	ret[ab]	v[global]	ounmenu
syn keyword vimCommand contained	cn[ext]	ju[mps]	rew[ind]	ve[rsion]	tm
syn keyword vimCommand contained	cno[remap]	k	ri[ght]	vi[sual]	tmenu
syn keyword vimCommand contained	cnorea[bbrev]	l[ist]	rv[iminfo]	vie[w]	tu
syn keyword vimCommand contained	co[py]	la[st]	sN[ext]	vm[ap]	tunmenu
syn keyword vimCommand contained	con[tinue]	le[ft]	s[ubstitute]	vmap	unme
syn keyword vimCommand contained	conf[irm]	let	sa[rgument]	vmapc[lear]	unmenu
syn keyword vimCommand contained	cp[revious]	ls	sal[l]	vn[oremap]	vme
syn keyword vimCommand contained	cq	m[ove]	sbN[ext]	vu[nmap]	vmenu
syn keyword vimCommand contained	cq[uit]	ma[rk]	sb[uffer]	wN[ext]	vnoreme
syn keyword vimCommand contained	crewind	mak[e]	sba[ll]	w[rite]	vnoremenu
syn keyword vimCommand contained	cu[nmap]	map	sbl[ast]	wa[ll]	vunme
syn keyword vimCommand contained	cuna[bbrev]	mapc[lear]	sbm[odified]	wh[ile]	vunmenu
syn keyword vimCommand contained	d[elete]	marks	sbn[ext]

" All vimCommands are contained by vimIsCommands.
syn match vimIsCommand	"^\s*[a-zA-Z]\+"		transparent contains=vimCommand
syn match vimIsCommand	"[:|]\s*[a-zA-Z]\+"	transparent contains=vimCommand

" vimOptions are caught only when contained in a vimSet
syn keyword vimOption contained	ai	efm	iskeyword	ru	tagrelative
syn keyword vimOption contained	akm	ei	isp	ruler	tags
syn keyword vimOption contained	al	ek	isprint	sb	tbi
syn keyword vimOption contained	aleph	endofline	joinspaces	sbr	tbs
syn keyword vimOption contained	allowrevins	eol	js	sc	term
syn keyword vimOption contained	altkeymap	ep	keywordprg	scr	terse
syn keyword vimOption contained	ari	equalalways	kp	scroll	textauto
syn keyword vimOption contained	autoindent	equalprg	langmap	scrolljump	textmode
syn keyword vimOption contained	autowrite	errorbells	laststatus	scrolloff	textwidth
syn keyword vimOption contained	aw	errorfile	lazyredraw	scs	tf
syn keyword vimOption contained	background	errorformat	lbr	sect	tildeop
syn keyword vimOption contained	backspace	esckeys	lcs	sections	timeout
syn keyword vimOption contained	backup	et	linebreak	secure	timeoutlen
syn keyword vimOption contained	backupdir	eventignore	lines	sessionoptions	title
syn keyword vimOption contained	backupext	ex	lisp	sft	titlelen
syn keyword vimOption contained	bdir	expandtab	list	sh	titlestring
syn keyword vimOption contained	bex	exrc	listchars	shcf	tl
syn keyword vimOption contained	bg	ff	lmap	shell	tm
syn keyword vimOption contained	bin	ffs	ls	shellcmdflag	to
syn keyword vimOption contained	binary	fileformat	lz	shellpipe	top
syn keyword vimOption contained	biosk	fileformats	magic	shellquote	tr
syn keyword vimOption contained	bioskey	fk	makeef	shellredir	ts
syn keyword vimOption contained	bk	fkmap	makeprg	shelltype	tsl
syn keyword vimOption contained	breakat	fo	mat	shellxquote	ttimeout
syn keyword vimOption contained	brk	formatoptions	matchpairs	shiftround	ttimeoutlen
syn keyword vimOption contained	bs	formatprg	matchtime	shiftwidth	ttm
syn keyword vimOption contained	cf	fp	maxmapdepth	shm	ttybuiltin
syn keyword vimOption contained	ch	gcr	maxmem	shortmess	ttyfast
syn keyword vimOption contained	cin	gd	maxmemtot	shortname	ttym
syn keyword vimOption contained	cindent	gdefault	mef	showbreak	ttymouse
syn keyword vimOption contained	cink	gfn	mh	showcmd	ttyscroll
syn keyword vimOption contained	cinkeys	go	ml	showfulltag	ttytype
syn keyword vimOption contained	cino	guicursor	mls	showmatch	tw
syn keyword vimOption contained	cinoptions	guifont	mm	showmode	tx
syn keyword vimOption contained	cinw	guioptions	mmd	shq	uc
syn keyword vimOption contained	cinwords	guipty	mmt	si	ul
syn keyword vimOption contained	cmdheight	helpfile	mod	sidescroll	undolevels
syn keyword vimOption contained	co	helpheight	modeline	sj	updatecount
syn keyword vimOption contained	columns	hf	modelines	sm	updatetime
syn keyword vimOption contained	com	hh	modified	smartcase	ut
syn keyword vimOption contained	comments	hi	more	smartindent	vb
syn keyword vimOption contained	compatible	hid	mouse	smarttab	vbs
syn keyword vimOption contained	complete	hidden	mousehide	smd	verbose
syn keyword vimOption contained	confirm	highlight	mouset	sn	vi
syn keyword vimOption contained	cp	history	mousetime	so	viminfo
syn keyword vimOption contained	cpo	hk	mp	softtabstop	visualbell
syn keyword vimOption contained	cpoptions	hkmap	mps	sol	wa
syn keyword vimOption contained	cpt	hkmapp	nf	sp	wak
syn keyword vimOption contained	cscopetagorder	hkp	nrformats	splitbelow	warn
syn keyword vimOption contained	cscopeverbose	hl	nu	sr	wb
syn keyword vimOption contained	cscopexec	hls	number	srr	wc
syn keyword vimOption contained	csexec	hlsearch	pa	ss	wd
syn keyword vimOption contained	csta	ic	para	ssop	weirdinvert
syn keyword vimOption contained	cstagalways	icon	paragraphs	st	wh
syn keyword vimOption contained	csto	iconstring	paste	sta	whichwrap
syn keyword vimOption contained	csverb	ignorecase	patchmode	startofline	wildchar
syn keyword vimOption contained	def	im	path	sts	winaltkeys
syn keyword vimOption contained	define	inc	pm	su	winheight
syn keyword vimOption contained	dg	include	readonly	suffixes	wiv
syn keyword vimOption contained	dict	incsearch	remap	sw	wm
syn keyword vimOption contained	dictionary	inf	report	swapsync	wrap
syn keyword vimOption contained	digraph	infercase	restorescreen	sws	wrapmargin
syn keyword vimOption contained	dir	insertmode	revins	sxq	wrapscan
syn keyword vimOption contained	directory	is	ri	ta	writeany
syn keyword vimOption contained	ea	isf	rightleft	tabstop	writebackup
syn keyword vimOption contained	eb	isfname	rl	tag	writedelay
syn keyword vimOption contained	ed	isi	ro	tagbsearch	ws
syn keyword vimOption contained	edcompatible	isident	rs	taglength	ww
syn keyword vimOption contained	ef	isk

" These are the turn-off setting variants
syn keyword vimOption contained	noai	noerrorbells	nois	noru	notbs
syn keyword vimOption contained	noakm	noesckeys	nojoinspaces	noruler	noterse
syn keyword vimOption contained	noalkeymap	noet	nojs	nosb	notextauto
syn keyword vimOption contained	noallowrevins	noex	nolbr	nosc	notextmode
syn keyword vimOption contained	noari	noexpandtab	nolinebreak	noscs	notf
syn keyword vimOption contained	noautoindent	noexrc	nolisp	nosecure	notildeop
syn keyword vimOption contained	noautowrite	nofk	nolist	noshiftround	notimeout
syn keyword vimOption contained	noaw	nofkmap	nomagic	noshortname	notitle
syn keyword vimOption contained	nobackup	nogd	nomh	noshowcmd	noto
syn keyword vimOption contained	nobin	nogdefault	noml	noshowmatch	notop
syn keyword vimOption contained	nobinary	noguipty	nomod	noshowmode	notr
syn keyword vimOption contained	nobiosk	nohid	nomodeline	nosi	nottimeout
syn keyword vimOption contained	nobioskey	nohidden	nomodified	nosm	nottybuiltin
syn keyword vimOption contained	nobk	nohk	nomore	nosmartcase	nottyfast
syn keyword vimOption contained	nocin	nohkmap	nomousehide	nosmartindent	notx
syn keyword vimOption contained	nocindent	nohkmapp	nonu	nosmarttab	novb
syn keyword vimOption contained	nocompatible	nohkp	nonumber	nosmd	novisualbell
syn keyword vimOption contained	nocp	nohls	nopaste	nosn	nowa
syn keyword vimOption contained	nodg	nohlsearch	noreadonly	nosol	nowarn
syn keyword vimOption contained	nodigraph	noic	noremap	nosplitbelow	nowb
syn keyword vimOption contained	noea	noicon	norestorescreen	nosr	noweirdinvert
syn keyword vimOption contained	noeb	noignorecase	norevins	nosta	nowiv
syn keyword vimOption contained	noed	noim	nori	nostartofline	nowrap
syn keyword vimOption contained	noedcompatible	noincsearch	norightleft	nota	nowrapscan
syn keyword vimOption contained	noek	noinf	norl	notagbsearch	nowriteany
syn keyword vimOption contained	noendofline	noinfercase	noro	notagrelative	nowritebackup
syn keyword vimOption contained	noeol	noinsertmode	nors	notbi	nows
syn keyword vimOption contained	noequalalways

" termcap codes (which can also be set)
syn keyword vimOption contained	t_AB	t_RI	t_da	t_k9	t_ks	t_so
syn keyword vimOption contained	t_AF	t_Sb	t_db	t_kD	t_ku	t_sr
syn keyword vimOption contained	t_AL	t_Sf	t_dl	t_kI	t_le	t_te
syn keyword vimOption contained	t_CS	t_ZH	t_k1	t_kN	t_mb	t_ti
syn keyword vimOption contained	t_Co	t_ZR	t_k2	t_kP	t_md	t_ue
syn keyword vimOption contained	t_DL	t_al	t_k3	t_kb	t_me	t_us
syn keyword vimOption contained	t_F1	t_bc	t_k4	t_kd	t_mr	t_vb
syn keyword vimOption contained	t_F2	t_cd	t_k5	t_ke	t_ms	t_ve
syn keyword vimOption contained	t_K1	t_ce	t_k6	t_kh	t_nd	t_vi
syn keyword vimOption contained	t_K3	t_cl	t_k7	t_kl	t_op	t_vs
syn keyword vimOption contained	t_K4	t_cm	t_k8	t_kr	t_se	t_xs
syn keyword vimOption contained	t_K5	t_cs
syn match   vimOption contained	"t_#4"
syn match   vimOption contained	"t_%1"
syn match   vimOption contained	"t_%i"
syn match   vimOption contained	"t_&8"
syn match   vimOption contained	"t_@7"
syn match   vimOption contained	"t_k;"

" these settings don't actually cause errors in vim, but were supported by vi and don't do anything in vim
syn keyword vimErrSetting contained	ap	gr	op	slow	w1200
syn keyword vimErrSetting contained	autoprint	graphic	open	slowopen	w300
syn keyword vimErrSetting contained	beautify	hardtabs	optimize	sourceany	w9600
syn keyword vimErrSetting contained	bf	ht	prompt	tagstack	wi
syn keyword vimErrSetting contained	fl	mesg	redraw	tgst	window
syn keyword vimErrSetting contained	flash	novice

" AutoBuf Events
syn keyword vimAutoEvent contained	BufDelete	BufReadPre	FileAppendPre	FilterReadPost	TermChanged
syn keyword vimAutoEvent contained	BufEnter	BufUnload	FileChangedShell	FilterReadPre	User
syn keyword vimAutoEvent contained	BufLeave	BufWrite	FileReadPost	FilterWritePost	VimEnter
syn keyword vimAutoEvent contained	BufNewFile	BufWritePost	FileReadPre	FilterWritePre	VimLeave
syn keyword vimAutoEvent contained	BufRead	BufWritePre	FileWritePost	StdinReadPost	WinEnter
syn keyword vimAutoEvent contained	BufReadPost	FileAppendPost	FileWritePre	StdinReadPre	WinLeave

" Highlight commonly used Groupnames
syn keyword vimGroup	Comment	Identifier	Keyword	Type	Tag
syn keyword vimGroup	Constant	Function	Exception	StorageClass	Delimiter
syn keyword vimGroup	String	Statement	PreProc	Structure	SpecialComment
syn keyword vimGroup	Character	Conditional	Include	Typedef	Debug
syn keyword vimGroup	Number	Repeat	Define	Special	Error
syn keyword vimGroup	Boolean	Label	Macro	SpecialChar	Todo
syn keyword vimGroup	Float	Operator	PreCondit

" Default highlighting groups
syn keyword vimHLGroup	Cursor	LineNr	NonText	Search	Title
syn keyword vimHLGroup	Directory	Menu	Normal	SpecialKey	Visual
syn keyword vimHLGroup	ErrorMsg	ModeMsg	Question	StatusLine	WarningMsg
syn keyword vimHLGroup	IncSearch	MoreMsg	Scrollbar	StatusLineNC

" Function Names
syn keyword vimFuncName contained	argc	confirm	has	match	synID
syn keyword vimFuncName contained	argv	delete	hlID	matchend	synIDattr
syn keyword vimFuncName contained	bufexists	exists	hlexists	nr2char	synIDtran
syn keyword vimFuncName contained	bufname	expand	hostname	strftime	tempname
syn keyword vimFuncName contained	bufnr	filereadable	input	strlen	virtcol
syn keyword vimFuncName contained	char2nr	getcwd	isdirectory	strpart	winheight
syn keyword vimFuncName contained	col	getline	line	substitute
syn match vimFunc "\I\i*\s*("	contains=vimFuncName

"--- syntax above generated by mkvimvim ---
" Highlight syntax stuff

syn keyword vimPattern contained	start	skip	end

syn keyword vimSpecial	ALL	ccomment	matchgroup	skipempty	sync
syn keyword vimSpecial	NONE	lines	minlines	skipnl	transparent

" Highlight syntax stuff -- the following vimSpecials aren't keywords because Vim's syntax checking
" disapproves
syn match vimSpecial	contained	"\<ALLBUT\>"
syn match vimSpecial	contained	"\<clear\>"
syn match vimSpecial	contained	"\<contained\>"
syn match vimSpecial	contained	"\<oneline\>"
syn match vimSpecial	contained	"\<contains\>"
syn match vimSpecial	contained	"\<grouphere\>"
syn match vimSpecial	contained	"\<groupthere\>"
syn match vimSpecial	contained	"\<keepend\>"
syn match vimSpecial	contained	"\<maxlines\>"
syn match vimSpecial	contained	"\<nextgroup\>"
syn match vimSpecial	contained	"\<skipempty\>"
syn match vimSpecial	contained	"\<skipnl\>"
syn match vimSpecial	contained	"\<skipwhite\>"
syn match vimSpecial	contained	"\<transparent\>"

" Highlight Terminal Stuff
syn keyword vimTermSet  contained	background	cterm	ctermfg	font	gui	guifg
syn keyword vimTermSet  contained	bg	ctermbg	fg	foreground	guibg	term	start
syn match   vimTermSet  contained	"stop"

" Special Filenames and Modifiers
syn match vimSpecFile	"<\(cword\|cWORD\|[cas]file\)>"	nextgroup=vimSpecFileMod
syn match vimSpecFile	"#[0-9]\|[#%]"		nextgroup=vimSpecFileMod
syn match vimSpecFileMod	"\(:[phtre]\)\+"		contained

" Conditionals
syn match vimConditional	"^\s*\(continue\|con\)\>"
syn match vimConditional	"^\s*\(endif\|en\)\>"
syn match vimConditional	"^\s*\(endwhile\|endw\)\>"
syn match vimConditional	"^\s*\(while\|wh\)\>"
syn match vimConditional	"^\s*break\=\>"
syn match vimConditional	"^\s*else\>"
syn match vimConditional	"^\s*elseif\=\>"
syn match vimConditional	"^\s*if\>"

" Operators
syn match vimOper	"||\|&&\|!=\|>=\|<=\|=\~\|!\~\|>\|<\|+\|-\|=\|\." skipwhite nextgroup=vimString

" Numbers
syn match vimNumber	"\<[0-9]\+.[0-9]\+"
syn match vimNumber	"\<[0-9]\+L\="
syn match vimNumber	"-[0-9]\+.[0-9]\+"
syn match vimNumber	"-[0-9]\+L\="
syn match vimNumber	"[[;:][0-9]\+"lc=1
syn match vimNumber	"0[xX][0-9a-fA-F]\+"
syn match vimNumber	"#[0-9a-fA-F]\+"

" Lower Priority Comments: after some vim commands...
syn match vimComment	+\s"[^\-:.%#=*].*$+lc=1	contains=vimTodo
syn match vimComment	+\<endif\s\+".*$+lc=5	contains=vimTodo
syn match vimComment	+\<else\s\+".*$+lc=4	contains=vimTodo
syn match vimComment	+^\s*".*$+		contains=vimTodo

" Try to catch strings, if nothing else matches (therefore it must precede the others!)
"  vmEscapeBrace handles ["]  []"] (ie. stays as string)
syn region	vimEscapeBrace	start="[^\\]\(\\\\\)*\[\^\=\]\=" skip="\\\\\|\\\]" end="\]"me=e-1	oneline contained transparent
syn match	vimPatSep	"\\[|()]"hs=e-1	contained
syn match	vimNotPatSep	"\\\\"	contained
syn region	vimString	start=+[^:a-zA-Z>!\\]"+lc=1 skip=+\\\\\|\\"+ end=+"+ oneline contains=vimEscapeBrace,vimPatSep,vimNotPatSep
syn region	vimString	start=+[^:a-zA-Z>!\\]'+lc=1 skip=+\\\\\|\\'+ end=+'+ oneline contains=vimEscapeBrace,vimPatSep,vimNotPatSep
syn region	vimString	start=+=!+lc=1	skip=+\\\\\|\\!+ end=+!+	oneline contains=vimEscapeBrace,vimPatSep,vimNotPatSep
syn region	vimString	start="=+"lc=1	skip="\\\\\|\\+" end="+"	oneline contains=vimEscapeBrace,vimPatSep,vimNotPatSep
syn region	vimString	start="[^\\]+\s*[^a-zA-Z0-9.]"lc=1 skip="\\\\\|\\+" end="+"	oneline contains=vimEscapeBrace,vimPatSep,vimNotPatSep
syn region	vimString	start="\s/\s*[^a-zA-Z]"lc=1 skip="\\\\\|\\+" end="/"	oneline contains=vimEscapeBrace,vimPatSep,vimNotPatSep

" Substitutions
syn region	vimSubst	start=":\=s/.\{-}" skip="\(\\\\\)*\\/" end="/"	oneline contains=vimPatSep,vimSubstTwoBS,vimSubstRange,vimNotation nextgroup=vimSubstEnd
syn region	vimSubstEnd	start="."lc=1	skip="\(\\\\\)*\\/"   end="/"	oneline contained contains=vimSubstPat,vimSubstTwoBS,vimNotation
syn region	vimSubstRange	start="\["	skip="\(\\\\\)*\\]"   end="]"	oneline contained
syn match	vimSubstPat	"\\[0-9]"			contained
syn match	vimSubstTwoBS	"\\\\"			contained

" Marks, Registers, Addresses, Filters
syn match	vimMark	"[!,:]'[a-zA-Z0-9]"lc=1
syn match	vimMark	"'[a-zA-Z0-9][,!]"me=e-1
syn match	vimMark	"[^a-zA-Z]norm\s'[a-zA-Z0-9]"lc=6
syn match	vimMark	"[^a-zA-Z]normal\s'[a-zA-Z0-9]"lc=8
syn match	vimPlainMark	"'[a-zA-Z0-9]"		contained

syn match	vimRegister	'[^(,;]"[a-zA-Z0-9\-:.%#*=][^a-zA-Z_"]'lc=1
syn match	vimRegister	'[^a-zA-Z]norm\s"[a-zA-Z0-9]'lc=6
syn match	vimRegister	'[^a-zA-Z]normal\s"[a-zA-Z0-9]'lc=8
syn match	vimPlainRegister	'"[a-zA-Z0-9\-:.%#*=]'	contained

syn match	vimAddress	",\."lc=1
syn match   	vimAddress	"[:|][%.]"lc=1
syn match   	vimAddress	"<Bar>%"lc=5

syn match	vimFilter	":\s*!"ms=e
syn match	vimFilter	"[^a-zA-Z]!"lc=1

" Complex repeats (:h complex-repeat)
syn match vimCmplxRepeat	'[^a-zA-Z_/\\]q[0-9a-zA-Z"]'lc=1
syn match vimCmplxRepeat	'@[0-9a-z".=@:]'

" High Priority Comments: beginning of line with optional spaces then "
syn match vimComment	+^\s*".*$+	contains=vimTodo

" Set command and associated set-options (vimOptions) with comment
syn region vimSet matchgroup=vimCommand start="\s*set\>" end="|\|$"	keepend contains=vimSetEqual,vimOption,vimErrSetting,vimComment,vimSetString
syn region vimSetEqual  contained	start="="	skip="\(\\\\\)*\\\s" end="[| \t]\|$"me=e-1 contains=vimCtrlChar
syn region vimSetString contained	start=+="+hs=s+1	skip=+\(\\\\\)\\"+   end=+"+	contains=vimCtrlChar

" Highlight modifiers
syn keyword VimHLMod contained NONE bold inverse italic reverse standout underline

" Autocmd
syn match  vimIsCommand2 "[ \t<Bar>][a-zA-Z_]\+"lc=1 transparent contained contains=vimCommand
syn region vimAutoCmd matchgroup=vimAutoSet start=+^\s*\(autocmd\|au\)\>+	end="$" keepend contains=vimAutoEvent,vimSet,vimIsCommand,vimIsCommand2,vimString,vimComment,vimSpecFile,vimNotation,vimFilter,vimAuSynLine,vimAuRegion
syn region vimAutoCmd matchgroup=vimAutoSet start=+^\s*\(doautoa\|doautoall\)\>+	end="$" keepend contains=vimAutoEvent,vimSet,vimIsCommand,vimIsCommand2,vimString,vimComment,vimSpecFile,vimNotation,vimFilter,vimAuSynLine,vimAuRegion

" Syntax regions (all oneliners)
syn keyword vimKeyword link match		contained
syn keyword vimCase    ignore match	contained
syn keyword vimSynGroup add remove	contained
syn match   vimSynGroup "contains"	contained
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(highlight\|hi\)\s"	end="$"	keepend contains=vimKeyword,vimSpecial,vimGroup,vimTermSet,vimComment,vimCtrlChar,VimRegion,vimNotation,vimNumber,vimHLMod,vimOption,vimHLGroup
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+case"	end="$"	keepend contains=vimCase,vimComment
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+clear"rs=e-5 end="$"	keepend contains=vimSpecial,vimComment
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+cluster"	end="$"	keepend contains=vimSynGroup,vimComment
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+group"	end="$"	keepend contains=vimSynGroup,vimComment
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+include"	end="$"	keepend contains=vimComment,vimNotation
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+match"	end="$"	keepend contains=vimKeyword,vimSpecial,vimString,vimComment
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+region"	end="$"	keepend contains=vimKeyword,vimSpecial,vimString,vimPattern,vimComment
syn region vimRegion  matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+sync"	end="$"	keepend contains=vimKeyword,vimSpecial,vimString,vimComment
syn region vimSynLine matchgroup=vimKeyword start="^\s*\(syntax\|syn\)\s\+keyword"	end="$"	keepend contains=vimKeyword,vimSpecial,vimComment

syn region vimAuSynLine matchgroup=vimKeyword start="\s\(syntax\|syn\)\s\+keyword"lc=1 end="$"	keepend contains=vimKeyword,vimSpecial,vimComment contained
syn region vimAuRegion  matchgroup=vimKeyword start="\s\(syntax\|syn\)\s\+region"lc=1  end="$"	keepend contains=vimKeyword,vimSpecial,vimString,vimPattern,vimComment contained
syn region vimAuRegion  matchgroup=vimKeyword start="\s\(syntax\|syn\)\s\+match"lc=1	end="$"	keepend contains=vimKeyword,vimSpecial,vimString,vimComment contained
syn region vimAuRegion  matchgroup=vimKeyword start="\s\(syntax\|syn\)\s\+clear"rs=e-5 end="$"	keepend contains=vimSpecial,vimComment contained
syn region vimAuRegion  matchgroup=vimKeyword start="\s\(syntax\|syn\)\s\+case"lc=1 end="$"	keepend contains=vimCase,vimComment contained
syn region vimAuRegion  matchgroup=vimKeyword start="\s\(syntax\|syn\)\s\+sync"lc=1 end="$"	keepend contains=vimKeyword,vimSpecial,vimString,vimComment contained
syn region vimAuRegion  matchgroup=vimKeyword start="\s\(highlight\|hi\)\s"lc=1 end="$"	keepend contains=vimKeyword,vimSpecial,vimGroup,vimTermSet,vimComment,vimCtrlChar,VimRegion,vimNotation,vimNumber,vimHLMod,vimOption,vimHLGroup contained

" Angle-Bracket Notation
syn match vimNotation	"<[a-zA-Z][a-zA-Z0-9]\+>"		contains=vimBracket
syn match vimNotation	"<C-[A-Z]>"			contains=vimBracket
syn match vimNotation	"<[AM]-.>"			contains=vimBracket
syn match vimNotation	"<[SCAM]-\(Right\|Left\|Down\|Up\)>"	contains=vimBracket
syn match vimNotation	"<S-F[0-9]>"			contains=vimBracket
syn match vimNotation	'<C-R>[0-9a-z"%#:.\-=]'he=e-1		contains=vimBracket
syn match vimNotation	"<CR>"			contains=vimBracket nextgroup=vimPlainMark,vimPlainRegister,vimAddress
syn match vimNotation	"<Esc>"			contains=vimBracket nextgroup=vimPlainMark,vimPlainRegister,vimAddress
syn match vimBracket contained	"[<>]"

" Additional IsCommand stuff, here by reasons of precedence
syn match vimIsCommand	"<Bar>\s*[a-zA-Z]\+"	transparent contains=vimCommand,vimNotation

" Control Characters
syn match vimCtrlChar	"[--]"

if !exists("did_vim_syntax_inits")
  let did_vim_syntax_inits = 1
  " The default methods for highlighting.  Can be overridden later
  hi link vimAddress	vimMark
  hi link vimAutoSet	vimCommand
  hi link vimConditional	vimStatement
  hi link vimFilter	vimOper
  hi link vimHLGroup	vimGroup
  hi link vimNotPatSep	vimString
  hi link vimPlainMark	vimMark
  hi link vimPlainRegister	vimRegister
  hi link vimSetString	vimString
  hi link vimSpecFileMod	vimSpecFile
  hi link vimSynGroup	vimSpecial
  hi link vimTerminal	vimGroup

  hi link vimAutoEvent	Type
  hi link vimBracket	Delimiter
  hi link vimCmplxRepeat	SpecialChar
  hi link vimCommand	Statement
  hi link vimComment	Comment
  hi link vimCtrlChar	SpecialChar
  hi link vimErrSetting	Error
  hi link vimFuncName	Function
  hi link vimGroup	Type
  hi link vimHLMod	PreProc
  hi link vimKeyword	Statement
  hi link vimMark	Number
  hi link vimNotation	Special
  hi link vimNumber	Number
  hi link vimOper	Operator
  hi link vimOption	PreProc
  hi link vimPatSep	SpecialChar
  hi link vimPattern	Type
  hi link vimRegister	SpecialChar
  hi link vimSpecFile	Identifier
  hi link vimSpecial	Type
  hi link vimStatement	Statement
  hi link vimString	String
  hi link vimSubstPat	SpecialChar
  hi link vimTermSet	StorageClass
  hi link vimTodo	Todo
endif

let b:current_syntax = "vim"

" vim: ts=17
